Changes between Version 9 and Version 10 of TracInstall


Ignore:
Timestamp:
Dec 27, 2016, 1:09:11 AM (12 months ago)
Author:
trac
Comment:

Legend:

Unmodified
Added
Removed
Modified
  • TracInstall

    v9 v10  
    1 = Trac Installation Guide for 1.0
    2 
     1= Trac Installation Guide for 1.1
    32[[TracGuideToc]]
    43
    54Trac is written in the Python programming language and needs a database, [http://sqlite.org/ SQLite], [http://www.postgresql.org/ PostgreSQL], or [http://mysql.com/ MySQL]. For HTML rendering, Trac uses the [http://genshi.edgewall.org Genshi] templating system.
    65
    7 Since version 0.12, Trac can also be localized, and there is probably a translation available in your language. If you want to use the Trac interface in other languages, then make sure you have installed the optional package [#OtherPythonPackages Babel]. Pay attention to the extra steps for localization support in the [#InstallingTrac Installing Trac] section below. Lacking Babel, you will only get the default English version.
     6Trac can also be localized, and there is probably a translation available in your language. If you want to use the Trac interface in other languages, then make sure you have installed the optional package [#OtherPythonPackages Babel]. Pay attention to the extra steps for localization support in the [#InstallingTrac Installing Trac] section below. Lacking Babel, you will only get the default English version.
    87
    98If you're interested in contributing new translations for other languages or enhancing the existing translations, then please have a look at [trac:wiki:TracL10N TracL10N].
    109
    11 What follows are generic instructions for installing and setting up Trac. While you may find instructions for installing Trac on specific systems at [trac:TracInstallPlatforms TracInstallPlatforms] on the main Trac site, please '''first read through these general instructions''' to get a good understanding of the tasks involved.
     10What follows are generic instructions for installing and setting up Trac. While you may find instructions for installing Trac on specific systems at [trac:TracInstallPlatforms TracInstallPlatforms], please '''first read through these general instructions''' to get a good understanding of the tasks involved.
    1211
    1312[[PageOutline(2-3,Installation Steps,inline)]]
    1413
    1514== Dependencies
    16 
    1715=== Mandatory Dependencies
    18 
    1916To install Trac, the following software packages must be installed:
    2017
    21  * [http://www.python.org/ Python], version >= 2.5 and < 3.0
    22    (note that we dropped the support for Python 2.4 in this release)
     18 * [http://www.python.org/ Python], version >= 2.6 and < 3.0
     19   (note that we dropped the support for Python 2.5 in this release)
    2320 * [http://pypi.python.org/pypi/setuptools setuptools], version >= 0.6
    2421 * [http://genshi.edgewall.org/wiki/Download Genshi], version >= 0.6
     
    2825==== For the SQLite database #ForSQLite
    2926
    30 As you must be using Python 2.5, 2.6 or 2.7, you already have the SQLite database bindings bundled with the standard distribution of Python: the `sqlite3` module.
     27As you must be using Python 2.6 or 2.7, you already have the SQLite database bindings bundled with the standard distribution of Python (the `sqlite3` module).
    3128
    3229Optionally, you may install a newer version of [http://pypi.python.org/pypi/pysqlite pysqlite] than the one provided by the Python distribution. See [trac:PySqlite#ThePysqlite2bindings PySqlite] for details.
     
    4441Trac works well with MySQL, provided you follow the guidelines:
    4542
    46  * [http://mysql.com/ MySQL] or [http://mariadb.org/ MariaDB], version 5.0 or later
     43 * [http://mysql.com/ MySQL], version 5.0 or later
    4744 * [http://sf.net/projects/mysql-python MySQLdb], version 1.2.2 or later
    4845
    49 Given the caveats and known issues surrounding MySQL, read the [trac:MySqlDb] page before creating the database.
     46Given the caveats and known issues surrounding MySQL, read carefully the [trac:MySqlDb] page before creating the database.
    5047
    5148=== Optional Dependencies
    5249
    53 ==== Version Control System
    54 
    55 ===== Subversion
    56  * [http://subversion.apache.org/ Subversion], 1.5.x or later and the '''corresponding''' Python bindings. Older versions starting from 1.0, like 1.2.4, 1.3.2 or 1.4.2, etc. may still work. For troubleshooting information, check the [trac:TracSubversion#Troubleshooting TracSubversion] page.
     50==== Subversion
     51
     52[http://subversion.apache.org/ Subversion], 1.6.x or later and the '''''corresponding''''' Python bindings.
    5753
    5854There are [http://subversion.apache.org/packages.html pre-compiled SWIG bindings] available for various platforms. (Good luck finding precompiled SWIG bindings for any Windows package at that listing. [trac:TracSubversion] points you to [http://alagazam.net Alagazam], which works for me under Python 2.6.)
    5955
    60 Note that Trac '''doesn't''' use [http://pysvn.tigris.org/ PySVN], neither does it work yet with the newer `ctype`-style bindings.
    61 
    62 '''Note:''' if using Subversion, Trac must be installed on the '''same machine'''. Remote repositories are currently [trac:ticket:493 not supported].
    63 
    64 ===== Git
    65  * [http://git-scm.com/ Git] 1.5.6 or later.
    66 
    67 More information is available on the [trac:TracGit] page.
    68 
    69 ===== Others
    70 
    71 Support for other version control systems is provided via third-parties. See [trac:PluginList#VersionControlSystems] and [trac:VersionControlSystem].
     56For troubleshooting information, see the [trac:TracSubversion#Troubleshooting TracSubversion] page.
     57
     58{{{#!div style="border: 1pt dotted; margin: 1em"
     59**Note:**
     60* Trac '''doesn't''' use [http://pysvn.tigris.org/ PySVN], nor does it work yet with the newer `ctype`-style bindings.
     61* If using Subversion, Trac must be installed on the '''same machine'''. Remote repositories are currently [trac:ticket:493 not supported].
     62}}}
     63
     64==== Git
     65
     66[http://git-scm.com/ Git] 1.5.6 or later is supported. More information is available on the [trac:TracGit] page.
     67
     68==== Other Version Control Systems
     69
     70Support for other version control systems is provided via third-party plugins. See [trac:PluginList#VersionControlSystems] and [trac:VersionControlSystem].
    7271
    7372==== Web Server
    74 
    75 A web server is optional because Trac has a server included, see the [#RunningtheStandaloneServer Running the Standalone Server] section below.
     73A web server is optional because Trac is shipped with a server included, see the [#RunningtheStandaloneServer Running the Standalone Server] section below.
    7674
    7775Alternatively you can configure Trac to run in any of the following environments:
    7876 * [http://httpd.apache.org/ Apache] with
    79    - [http://code.google.com/p/modwsgi/ mod_wsgi], see [wiki:TracModWSGI] and
    80      http://code.google.com/p/modwsgi/wiki/IntegrationWithTrac
     77   - [https://github.com/GrahamDumpleton/mod_wsgi mod_wsgi], see [wiki:TracModWSGI] and
     78     [http://code.google.com/p/modwsgi/wiki/IntegrationWithTrac ModWSGI IntegrationWithTrac].
    8179   - [http://modpython.org/ mod_python 3.5.0], see TracModPython
    8280 * a [http://www.fastcgi.com/ FastCGI]-capable web server (see TracFastCgi)
    8381 * an [http://tomcat.apache.org/connectors-doc/ajp/ajpv13a.html AJP]-capable web
    8482   server (see [trac:TracOnWindowsIisAjp TracOnWindowsIisAjp])
    85  * a FastCGI and FastCGI-to-WSGI gateway (see [trac:TracOnWindowsIisWfastcgi])
    86  * a CGI-capable web server (see TracCgi), but //usage of Trac as a cgi script
    87    is highly discouraged//, better use one of the previous options.
     83 * Microsoft IIS with FastCGI and a FastCGI-to-WSGI gateway (see [trac:CookBook/Installation/TracOnWindowsIisWfastcgi IIS with FastCGI])
     84 * a CGI-capable web server (see TracCgi), '''but usage of Trac as a cgi script
     85   is highly discouraged''', better use one of the previous options.
    8886   
     87
    8988==== Other Python Packages
    9089
    91  * [http://babel.edgewall.org Babel], version 0.9.5, 0.9.6 or >= 1.3
     90 * [http://babel.edgewall.org Babel], version 0.9.6 or >= 1.3,
    9291   needed for localization support
    9392 * [http://docutils.sourceforge.net/ docutils], version >= 0.3.9
     
    9594 * [http://pygments.org Pygments] for
    9695   [TracSyntaxColoring syntax highlighting].
    97    [http://silvercity.sourceforge.net/ SilverCity] and/or
    98    [http://gnu.org/software/enscript/enscript.html Enscript] may still be used
    99    but are deprecated and you really should be using Pygments.
    10096 * [http://pytz.sf.net pytz] to get a complete list of time zones,
    10197   otherwise Trac will fall back on a shorter list from
     
    106102}}}
    107103
    108 Please refer to the documentation of these packages to find out how they are best installed. In addition, most of the [trac:TracInstallPlatforms platform-specific instructions] also describe the installation of the dependencies. Keep in mind however that the information there probably concern older versions of Trac than the one you're installing.
     104Please refer to the documentation of these packages to find out how they are best installed. In addition, most of the [trac:TracInstallPlatforms platform-specific instructions] also describe the installation of the dependencies. Keep in mind however that the information there ''probably concern older versions of Trac than the one you're installing''.
    109105
    110106== Installing Trac
     
    112108The [TracAdmin trac-admin] command-line tool, used to create and maintain [TracEnvironment project environments], as well as the [TracStandalone tracd] standalone server are installed along with Trac. There are several methods for installing Trac.
    113109
    114 It is assumed throughout this guide that you have elevated permissions as the `root` user, or by prefixing commands with `sudo`. The umask `0022` should be used for a typical installation on a Unix-based platform.
     110It is assumed throughout this guide that you have elevated permissions as the `root` user or by prefixing commands with `sudo`. The umask `0002` should be used for a typical installation on a Unix-based platform.
    115111
    116112=== Using `easy_install`
    117 
    118 Trac can be installed from [https://pypi.python.org/pypi/Trac PyPI] or the Subversion repository using [http://pypi.python.org/pypi/setuptools setuptools].
    119 
    120 A few command-line examples:
     113Trac can be installed from PyPI or the Subversion repository using [http://pypi.python.org/pypi/setuptools setuptools].
     114
     115A few examples:
    121116
    122117 - Install the latest stable version of Trac:
     
    129124}}}
    130125   Note that in this case you won't have the possibility to run a localized version of Trac;
    131    either use a released version or install from source.
     126   either use a released version or install from source 
    132127
    133128More information can be found on the [trac:wiki:setuptools setuptools] page.
     
    138133
    139134=== Using `pip`
    140 
    141 'pip' is an easy_install replacement that is very useful to quickly install Python packages.
     135'pip' is an easy_install replacement that is very useful to quickly install python packages.
    142136To get a Trac installation up and running in less than 5 minutes:
    143137
    144 Assuming you want to have your entire pip installation in `/opt/user/trac`:
     138Assuming you want to have your entire pip installation in `/opt/user/trac`
    145139
    146140 -
    147141 {{{#!sh
    148 $ pip install trac psycopg2
    149 }}}
    150 or:
     142pip install trac psycopg2
     143}}}
     144or
    151145 -
    152146 {{{#!sh
    153 $ pip install trac mysql-python
     147pip install trac mysql-python
    154148}}}
    155149
     
    158152pip will automatically resolve all dependencies (like Genshi, pygments, etc.), download the latest packages from pypi.python.org and create a self contained installation in `/opt/user/trac`.
    159153
    160 All commands (`tracd`, `trac-admin`) are available in `/opt/user/trac/bin`. This can also be leveraged for `mod_python` (using `PythonHandler` directive) and `mod_wsgi` (using `WSGIDaemonProcess` directive).
     154All commands (`tracd`, `trac-admin`) are available in `/opt/user/trac/bin`. This can also be leveraged for `mod_python` (using `PythonHandler` directive) and `mod_wsgi` (using `WSGIDaemonProcess` directive)
    161155
    162156Additionally, you can install several Trac plugins (listed [https://pypi.python.org/pypi?:action=browse&show=all&c=516 here]) through pip.
    163157
    164158=== From source
    165 
    166159Using the python-typical setup at the top of the source directory also works. You can obtain the source for a .tar.gz or .zip file corresponding to a release (e.g. `Trac-1.0.tar.gz`) from the [trac:TracDownload] page, or you can get the source directly from the repository. See [trac:TracRepositories#OfficialSubversionrepository TracRepositories] for details.
    167160
     
    170163}}}
    171164
    172 You will need root permissions or equivalent for this step.
     165''You will need root permissions or equivalent for this step.''
    173166
    174167This will byte-compile the Python source code and install it as an .egg file or folder in the `site-packages` directory
     
    179172$ python ./setup.py install
    180173}}}
    181 
    182174Alternatively, you can run `bdist_egg` and copy the .egg from `dist/` to the place of your choice, or you can create a Windows installer (`bdist_wininst`).
    183175
    184176=== Using installer
    185177
    186 On Windows Trac can be installed using the exe installers available on the [trac:TracDownload] page. Installers are available for the 32 and 64 bit versions of Python. Make sure to use the installer that matches the architecture of your Python installation.
     178On Windows, Trac can be installed using the exe installers available on the [trac:TracDownload] page. Installers are available for the 32-bit and 64-bit versions of Python. Make sure to use the installer that matches the architecture of your Python installation.
    187179
    188180=== Using package manager
    189181
    190 Trac may be available in the package repository for your platform. Note however, that the version provided by the package manager may not be the latest release.
     182Trac may be available in your platform's package repository. Note however, that the version provided by your package manager may not be the latest release.
    191183
    192184=== Advanced `easy_install` Options
     
    194186To install Trac to a custom location, or find out about other advanced installation options, run:
    195187{{{#!sh
    196 $ easy_install --help
     188easy_install --help
    197189}}}
    198190
     
    201193Specifically, you might be interested in:
    202194{{{#!sh
    203 $ easy_install --prefix=/path/to/installdir
    204 }}}
    205 
     195easy_install --prefix=/path/to/installdir
     196}}}
    206197or, if installing Trac on a Mac OS X system:
    207198{{{#!sh
    208 $ easy_install --prefix=/usr/local --install-dir=/Library/Python/2.5/site-packages
    209 }}}
    210 
    211 '''Note''': If installing on Mac OS X 10.6 running {{{ easy_install http://svn.edgewall.org/repos/trac/trunk }}} will install into {{{ /usr/local }}} and {{{ /Library/Python/2.5/site-packages }}} by default.
    212 
    213 The above will place your `tracd` and `trac-admin` commands into `/usr/local/bin` and will install the Trac libraries and dependencies into `/Library/Python/2.5/site-packages`, which is Apple's preferred location for third-party Python application installations.
     199easy_install --prefix=/usr/local --install-dir=/Library/Python/2.6/site-packages
     200}}}
     201
     202{{{#!div style="border: 1pt dotted; margin: 1em"
     203**Mac OS X Note:** On Mac OS X 10.6,  running `easy_install trac` will install into `/usr/local` and `/Library/Python/2.6/site-packages` by default.
     204
     205The `tracd` and `trac-admin` commands will be placed in `/usr/local/bin` and will install the Trac libraries and dependencies into `/Library/Python/2.6/site-packages`, which is Apple's preferred location for third-party Python application installations.
     206}}}
    214207
    215208== Creating a Project Environment
    216209
    217 A [TracEnvironment Trac environment] is the backend where Trac stores information like wiki pages, tickets, reports, settings, etc. An environment is basically a directory that contains a human-readable [TracIni configuration file], and other files and directories.
     210A [TracEnvironment Trac environment] is the backend where Trac stores information like wiki pages, tickets, reports, settings, etc. An environment is a directory that contains a human-readable [TracIni configuration file], and other files and directories.
    218211
    219212A new environment is created using [TracAdmin trac-admin]:
     
    222215}}}
    223216
    224 [TracAdmin trac-admin] will prompt you for the information it needs to create the environment, such as the name of the project and the [TracEnvironment#DatabaseConnectionStrings database connection string]. If you're not sure what to specify for one of these options, just press `<Enter>` to use the default value.
    225 
    226 Using the default database connection string in particular will always work as long as you have SQLite installed.
    227 For the other [trac:DatabaseBackend database backends] you should plan ahead and already have a database ready to use at this point.
    228 
    229 Since 0.12, Trac doesn't ask for a [TracEnvironment#SourceCodeRepository source code repository] anymore when creating an environment. Repositories can be [TracRepositoryAdmin added] afterwards, and support for specific version control systems is disabled by default.
    230 
    231 Also note that the values you specify here can be changed later by directly editing the [TracIni conf/trac.ini] configuration file.
     217[TracAdmin trac-admin] will prompt you for the information it needs to create the environment: the name of the project and the [TracEnvironment#DatabaseConnectionStrings database connection string]. If you're not sure what to specify for any of these options, just press `<Enter>` to use the default value.
     218
     219Using the default database connection string will always work as long as you have SQLite installed. For the other [trac:DatabaseBackend database backends] you should plan ahead and already have a database ready to use at this point.
     220
     221Also note that the values you specify here can be changed later using TracAdmin or directly editing the [TracIni conf/trac.ini] configuration file.
    232222
    233223{{{#!div style="border: 1pt dotted; margin: 1em"
     
    237227Finally, make sure the user account under which the web front-end runs will have '''write permissions''' to the environment directory and all the files inside. This will be the case if you run `trac-admin ... initenv` as this user. If not, you should set the correct user afterwards. For example on Linux, with the web server running as user `apache` and group `apache`, enter:
    238228{{{#!sh
    239 $ chown -R apache.apache /path/to/myproject
    240 }}}
    241 
    242 The actual username and groupname of the Apache server may not be exactly `apache`, and are specified in the Apache configuration file by the directives `User` and `Group` (if Apache `httpd` is what you use).
     229$ chown -R apache:apache /path/to/myproject
     230}}}
     231
     232The actual username and groupname of the apache server may not be exactly `apache`, and are specified in the Apache configuration file by the directives `User` and `Group` (if Apache `httpd` is what you use).
    243233
    244234{{{#!div class=important
     
    284274 - [wiki:TracModWSGI Apache with mod_wsgi]
    285275 - [TracModPython Apache with mod_python]
    286  - //[TracCgi CGI]: should not be used, as it degrades performance//
     276 - //[TracCgi CGI] (should not be used, as the performance is far from optimal)//
    287277
    288278Trac also supports [trac:TracOnWindowsIisAjp AJP] which may be your choice if you want to connect to IIS. Other deployment scenarios are possible: [trac:TracNginxRecipe nginx], [http://projects.unbit.it/uwsgi/wiki/Example#Traconapacheinasub-uri uwsgi], [trac:TracOnWindowsIisIsapi Isapi-wsgi] etc.
     
    294284There is, however, a bit of a chicken-and-egg problem. The [TracAdmin trac-admin] command requires an existing environment to function, but complains if the deploy directory already exists. This is a problem, because environments are often stored in a subdirectory of the deploy. The solution is to do something like this:
    295285{{{#!sh
    296 $ mkdir -p /usr/share/trac/projects/my-project
    297 $ trac-admin /usr/share/trac/projects/my-project initenv
    298 $ trac-admin /usr/share/trac/projects/my-project deploy /tmp/deploy
    299 $ mv /tmp/deploy/* /usr/share/trac
    300 }}}
    301 
     286mkdir -p /usr/share/trac/projects/my-project
     287trac-admin /usr/share/trac/projects/my-project initenv
     288trac-admin /usr/share/trac/projects/my-project deploy /tmp/deploy
     289mv /tmp/deploy/* /usr/share/trac
     290}}}
    302291Don't forget to check that the web server has the execution right on scripts in the `/usr/share/trac/cgi-bin` directory.
    303292
     
    402391Please refer to one of the following sections:
    403392 * TracStandalone#UsingAuthentication if you use the standalone server, `tracd`.
    404  * [wiki:TracModWSGI#ConfiguringAuthentication TracModWSGI#ConfiguringAuthentication] if you use the Apache web server, with any of its front end: `mod_wsgi` of course, but the same instructions applies also for `mod_python`, `mod_fcgi` or `mod_fastcgi`.
    405  * TracFastCgi if you are using another web server with FCGI support, such as Cherokee, Lighttpd, !LiteSpeed, nginx.
    406 
    407 The following document also contains some useful information for beginners: [trac:TracAuthenticationIntroduction].
     393 * [wiki:TracModWSGI#ConfiguringAuthentication TracModWSGI#ConfiguringAuthentication] if you use the Apache web server, with any of its front end: `mod_wsgi`, `mod_python`, `mod_fcgi` or `mod_fastcgi`.
     394 * TracFastCgi if you're using another web server with FCGI support (Cherokee, Lighttpd, !LiteSpeed, nginx)
     395
     396[trac:TracAuthenticationIntroduction] also contains some useful information for beginners.
    408397
    409398== Granting admin rights to the admin user
    410 
    411399Grant admin rights to user admin:
    412400{{{#!sh
     
    414402}}}
    415403
    416 This user will have an "Admin" entry menu that will allow you to administrate your Trac project.
    417 
    418 == Finishing the install
    419 
    420 === Enable version control components
    421 
    422 Support for version control systems is provided by optional components in Trac and the components are disabled by default //(since 1.0)//. Subversion and Git must be explicitly enabled if you wish to use them. See TracRepositoryAdmin for more details.
    423 
    424 The version control systems are enabled by adding the following to the `[components]` section of your [TracIni#components-section trac.ini], or enabling the components in the "Plugins" admin panel:
    425 
    426 {{{#!ini
    427 [components]
    428 tracopt.versioncontrol.svn.* = enabled
    429 }}}
    430 
    431 {{{#!ini
    432 [components]
    433 tracopt.versioncontrol.git.* = enabled
    434 }}}
    435 
    436 After enabling the components, repositories can be configured through the //Repositories// admin panel or by editing [TracIni#repositories-section trac.ini]. Automatic changeset references can be inserted as ticket comments by configuring [TracRepositoryAdmin#Automaticchangesetreferencesintickets CommitTicketUpdater].
    437 
    438 === Using Trac
     404This user will have an //Admin// navigation item that directs to pages for administering your Trac project.
     405
     406== Configuring Trac
     407
     408TracRepositoryAdmin provides information on configuring version control repositories for your project.
     409
     410== Using Trac
    439411
    440412Once you have your Trac site up and running, you should be able to create tickets, view the timeline, browse your version control repository if configured, etc.